package scripts;

import jinro.*;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.dnd.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.*;

class Initialize {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("Initialize.properties");
	def init() {
		def game = JinroInterface.mainwindow.menuBar.items.toList().find{ it.text == JinroInterface.getTextWithMnemonic("menu.game") };
		def entry = setMenuText(game.menu.items.toList().find{ it.text == JinroInterface.getTextWithMnemonic("menu.game.entry") }, "menu.game.skype");
		entry.addSelectionListener([
			widgetSelected: {
				JinroGame.invokeMethod("watchGeneralChat", [] as Object[]);
			}
		] as SelectionAdapter);
		game.menu.items.toList().find{ it.text == JinroInterface.getTextWithMnemonic("menu.game.start") }.enabled = false;
	}
	def setMenuText(item, prop) {
		def text = new StringBuilder(strings.getString(prop));
		int index = text.size() + 1;
		while(index && (index = text.lastIndexOf("&", index - 1)) >= 0) {
			text.replace(index, index, "&");
		}
		def mnemonic = strings.getString(prop + ".key");
		if(mnemonic.size() == 1 && mnemonic != "&") {
			index = text.indexOf(mnemonic);
			if(index < 0) {
				index = text.indexOf(mnemonic.toLowerCase());
				if(index < 0) {
					index = text.indexOf(mnemonic.toUpperCase());
				}
			}
			if(index >= 0) {
				text.replace(index, index, "&");
			} else {
				text << "(&" << mnemonic << ")";
			}
		}
		item.text = text;
		return item;
	}
	def asyncExec = { closure ->
		JinroInterface.display.asyncExec([ run: closure ] as Thread);
	}
}
