package scripts;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.text.*;
import jinro.*;

class Initialize {
	def static strings = JinroLocalization.getBundle("JinroInterface.properties").attachBundle("Initialize.properties");
	def init() {
		def game = JinroInterface.mainwindow.JMenuBar.subElements.toList().find{ (it instanceof JMenu) && it.text == JinroInterface.getTextWithMnemonic("menu.game") };
		def entry = setMenuText(game.menuComponents.toList().find{ it instanceof JMenuItem && it.text == JinroInterface.getTextWithMnemonic("menu.game.entry") }, "menu.game.skype");
		entry.addActionListener([
			actionPerformed: {
				JinroGame.invokeMethod("watchGeneralChat", [] as Object[]);
			}
		] as ActionListener);
		game.menuComponents.toList().find{ it instanceof JMenuItem && it.text == JinroInterface.getTextWithMnemonic("menu.game.start") }.enabled = false;
	}
	def setMenuText(item, prop) {
		def text = strings.getString(prop);
		def mnemonic = strings.getString(prop + ".key");
		if(mnemonic.size() == 1 && mnemonic != "&" && !JinroInterface.isMac) {
			if(text.toLowerCase().indexOf(mnemonic.toLowerCase()) < 0) {
				text += "(" + mnemonic + ")";
			}
			item.mnemonic = mnemonic.charAt(0);
		}
		item.text = text;
		return item;
	}
	def asyncExec = { closure ->
		SwingUtilities.invokeLater([ run: closure ] as Thread);
	}
}
